---
rules:
- id: route-handlers
  languages: [go]
  message: Make sure route handler functions match the method
  patterns:
  - pattern-inside: |
      func $FUNC($R *gin.Engine) {
        ...
      }
  - pattern-inside:
      $R.$METHOD(..., $HANDLER)
  - metavariable-pattern:
      metavariable: $METHOD
      pattern: "GET"
  - metavariable-pattern:
      metavariable: $HANDLER
      patterns:
        - pattern-not-regex: "Get$"
  severity: WARNING
